#include "bot.h"
#include "cardutil.h"

#include <Qt>

Bot::Bot(){
    cardUtil = new CardUtil();
}

int Bot::botInAction(int enemyCards[4],int cardsInCentral[8]){
    int returnedCardId = 0;

    if(cardUtil->howManyCardsInCentral(cardsInCentral) == -1){
        returnedCardId = botStartTheRound(enemyCards);
    }else{ //The player started
        if(!cardUtil->isCard(cardsInCentral[cardUtil->howManyCardsInCentral(cardsInCentral)],0)){
            int tmp = cardJustLikeThat(cardsInCentral,enemyCards,cardUtil->howManyCardsInCentral(cardsInCentral));
            if(tmp >= 0){
                returnedCardId = tmp;
            }else{
                if((getSevenCardIdFromEnemyCards(enemyCards) != -1) && (cardUtil->isCard(cardsInCentral[0],3) || cardUtil->isCard(cardsInCentral[0],7))){
                    returnedCardId = getSevenCardIdFromEnemyCards(enemyCards);
                }else{
                    returnedCardId = getNonTenAndAceAndMaybeSeven(enemyCards);
                }
            }
        }else{
            if(cardUtil->howManyCardsInCentral(cardsInCentral) == 0){
                returnedCardId = getNonTenAndAceAndMaybeSeven(enemyCards);
            }else{
                returnedCardId = answerToSevenCard(enemyCards,cardsInCentral);
            }
        }
    }
    return returnedCardId;
}

bool Bot::haveBotTrumpCard(int enemyCards[4],int cardsInCentral[8]){
    if(cardUtil->getCardRow(cardsInCentral[0]) != 0){ //Not seven
        for(int i=0;i<4;i++){
            if(enemyCards[i] != -1){
                if((cardUtil->getCardRow(enemyCards[i]) == cardUtil->getCardRow(cardsInCentral[0]))){
                    return true;
                }
                if(cardUtil->getCardRow(enemyCards[i]) == 0){
                    if((cardUtil->getCardRow(cardsInCentral[0]) == 3) || (cardUtil->getCardRow(cardsInCentral[0]) == 7)){
                        return true;
                    }
                }
            }
        }
    }
    return false;
}

//if 4 ten or ace, add this
//if 3 ten or ace, rand %3 and !=2, add this
//if 2 ten or ace, rand %2 and !=1, add this
//if 1 ten or ace, not add
int Bot::botStartTheRound(int enemyCards[4]){
    int returned = getNonTenAndAceAndMaybeSeven(enemyCards);
    if(cardUtil->isCard(enemyCards[returned],0) || cardUtil->isCard(enemyCards[returned],3) || cardUtil->isCard(enemyCards[returned],7)){
        if(howManyCardsInEnemysCards(enemyCards,3) > howManyCardsInEnemysCards(enemyCards,7)){
            for(int i=0;i<4;i++)
                if(cardUtil->isCard(enemyCards[i],3))
                    return i;
        }else{
            for(int i=0;i<4;i++)
                if(cardUtil->isCard(enemyCards[i],7))
                    return i;
        }
    }

    if((howManyCardsInEnemysCards(enemyCards,3) > 0) && (howManyCardsInEnemysCards(enemyCards,3)+howManyCardsInEnemysCards(enemyCards,0) == 3)){
        int rand = qrand()%3;
        if(rand != 2){
            for(int i=0;i<4;i++)
                if(cardUtil->isCard(enemyCards[i],3))
                    return i;
        }
    }

    if((howManyCardsInEnemysCards(enemyCards,7) > 0) && (howManyCardsInEnemysCards(enemyCards,7)+howManyCardsInEnemysCards(enemyCards,0) == 3)){
        int rand = qrand()%3;
        if(rand != 2){
            for(int i=0;i<4;i++)
                if(cardUtil->isCard(enemyCards[i],7))
                    return i;
        }
    }

    if((howManyCardsInEnemysCards(enemyCards,3) > 0) && (howManyCardsInEnemysCards(enemyCards,3)+howManyCardsInEnemysCards(enemyCards,0) == 2)){
        int rand = qrand()%2;
        if(rand != 1){
            for(int i=0;i<4;i++)
                if(cardUtil->isCard(enemyCards[i],3))
                    return i;
        }
    }

    if((howManyCardsInEnemysCards(enemyCards,7) > 0) && (howManyCardsInEnemysCards(enemyCards,7)+howManyCardsInEnemysCards(enemyCards,0) == 2)){
        int rand = qrand()%2;
        if(rand != 1){
            for(int i=0;i<4;i++)
                if(cardUtil->isCard(enemyCards[i],7))
                    return i;
        }
    }

     //Forexample, the bot has got two 8 cards, add this ... if have got two seven, don't add this
    for(int i=1;i<8;i++){
        if(howManyCardsInEnemysCards(enemyCards,i) >= 2){
            for(int j=0;j<4;j++){
                if(cardUtil->isCard(enemyCards[j],i)){
                    return j;
                }
            }
        }
    }

    return returned;
}

int Bot::answerToSevenCard(int enemyCards[4],int cardsInCentral[8]){
    int returned = -1;
    for(int i=0;i<4;i++){
        if(enemyCards[i] != 0){
            if(cardUtil->getCardRow(enemyCards[i]) == cardUtil->getCardRow(cardsInCentral[0])){
                return i;
            }
        }
    }

    if((cardUtil->getCardRow(cardsInCentral[0]) == 3) || (cardUtil->getCardRow(cardsInCentral[0]) == 7)){
        for(int i=0;i<4;i++){
            if(enemyCards[i] != -1){
                if(cardUtil->getCardRow(enemyCards[i]) == 0){
                    return i;
                }
            }
        }
    }

    returned = getNonTenAndAceAndMaybeSeven(enemyCards);
    return returned;
}

int Bot::getSevenCardIdFromEnemyCards(int enemyCards[4]){
    int returned = -1;
    for(int i=0;i<4;i++){
        if((enemyCards[i] != -1) && (cardUtil->getCardRow(enemyCards[i]) == 0)){
            returned = i;
        }
    }
    return returned;
}

int Bot::howManyCardsInEnemysCards(int enemyCards[4],int cardType){

    int ten = 0;
    for(int i=0;i<4;i++)
        for(int j=0;j<4;j++)
            if(enemyCards[i] == cardUtil->cards[cardType][j])
            //if(enemyCards[i] == cards[cardType][j])
                ten++;
    return ten;
}

//This method return non ten and non ace, but if bot have non seven too, add non seven
int Bot::getNonTenAndAceAndMaybeSeven(int enemyCards[4]){
    //If the bot have non ten, non ace and non seven, return this card ID
    for(int i=0;i<4;i++){
        if(enemyCards[i] != -1){
            if(!cardUtil->isCard(enemyCards[i],3) && !cardUtil->isCard(enemyCards[i],7) && !cardUtil->isCard(enemyCards[i],0)){
                return i;
            }
        }
    }

    //If the bot have only ten,ace and seven, the bot return seven card ID
    for(int i=0;i<4;i++){
        if(enemyCards[i] != -1){
            if(!cardUtil->isCard(enemyCards[i],3) && !cardUtil->isCard(enemyCards[i],7)){
                return i;
            }
        }
    }

    //If the bot have only ten and ace, return the fewer card ID
    int ace = 0;
    int ten = 0;
    for(int i=0;i<4;i++){
        if(enemyCards[i] != -1){
            if(cardUtil->isCard(enemyCards[i],3))
                ten++;
            if(cardUtil->isCard(enemyCards[i],7))
                ace++;
        }
    }

    // != 0 !!!
    if(ten == ace){
        if(qrand()%2 == 0)
            ace++;
        else
            ten++;
    }

    if(ten > ace){
        for(int i=0;i<4;i++){
            if(enemyCards[i] != -1){
                if(ace != 0){
                    if(cardUtil->isCard(enemyCards[i],7))
                        return i;
                }else{
                        return i;
                }
            }
        }
    }else{
        for(int i=0;i<4;i++){
            if(enemyCards[i] != -1){
                if(ten != 0){
                    if(cardUtil->isCard(enemyCards[i],3))
                        return i;
                }else{
                        return i;
                }
            }
        }
    }

    return 0;
}

//Ugyanolyan kartya
int Bot::cardJustLikeThat(int cardsInCentral[8],int enemyCards[4],int cardNumber){

    int row = 0;
    for(int i=0;i<8;i++){
        for(int j=0;j<4;j++){
            if(cardsInCentral[cardNumber] == cardUtil->cards[i][j]){
                row = i;
            }
        }
    }

    int tmp = -1;
    for(int i=0;i<4;i++){
        for(int j=0;j<4;j++){
            if(enemyCards[i] == cardUtil->cards[row][j]){
                tmp = i;
            }
        }
    }
    return tmp;
}

Bot::~Bot(){
    delete cardUtil;
}
