#include <QtCore/QSize>
#include "cardutil.h"

CardUtil::CardUtil(){
    int tmp = 0;
    for(int i=0;i<4;i++)
        for(int j=0;j<8;j++){
            tmp++;
            cards[j][i] = tmp;
        }
}

int CardUtil::getCardRow(int cardId){
    int row = 0;
    for(int i=0;i<8;i++)
        for(int j=0;j<4;j++)
            if(cardId == cards[i][j])
                row = i;
    return row;
}

int CardUtil::howManyCardsInCentral(int cardsInCentral[8]){
    int cardsInCentralCount = 0;
    for(int i=0;i<8;i++)
        if(cardsInCentral[i] != -1)
            cardsInCentralCount++;
    return cardsInCentralCount-1;
}

bool CardUtil::isNullCardsInEnemyAndPlayer(int enemyCards[4],int playerCards[4]){
    bool nullCardsInEnemyAndPlayer = true;
    for(int i=0;i<4;i++){
        if((enemyCards[i] != -1) || (playerCards[i] != -1)){
            nullCardsInEnemyAndPlayer = false;
        }
    }
    return nullCardsInEnemyAndPlayer;
}

bool CardUtil::isCard(int idCard,int cardType){
    bool ok = false;
    for(int i=0;i<4;i++){
        if(idCard == cards[cardType][i]){
            ok = true;
        }
    }
    return ok;
}

int CardUtil::howManyPoints(int cardsInCentral[8]){
    int points = 0;
    for(int i=0;i<=howManyCardsInCentral(cardsInCentral);i++){
        if(getCardRow(cardsInCentral[i]) == 3 || getCardRow(cardsInCentral[i]) == 7)
            points++;
    }
    return points*10;
}

void CardUtil::deleteDeckOfCards(int* sortOfDeckOfCards){
    for(int i=0;i<32;i++)
        sortOfDeckOfCards[i] = -1;
}

/*bool CardUtil::haveBotTrumpCard(int cards[4],int firstCardInCardsInCentral){
    bool returned = false;


    return returned;
}*/

bool CardUtil::havePlayerTrumpCard(int cards[4],int firstCardInCardsInCentral){
    for(int i=0;i<4;i++)
        if(cards[i] != -1)
            if((getCardRow(cards[i]) == getCardRow(firstCardInCardsInCentral)) || (getCardRow(cards[i]) == 0))
                return true;
    return false;
}

void CardUtil::setPlayerEnabledCardsWhenHaveTrumpCard(int cards[4],bool* enabledCards,int firstCardInCardsInCentral){
    for(int i=0;i<4;i++)
        enabledCards[i] = false;

    for(int i=0;i<4;i++){
        if(cards[i] != -1){
            if((getCardRow(cards[i]) == getCardRow(firstCardInCardsInCentral)) || (getCardRow(cards[i]) == 0)){
                enabledCards[i] = true;
            }
        }
    }
}

void CardUtil::setDeckOfCards(int* sortOfDeckOfCards){
    for(int i=0;i<32;i++){
        sortOfDeckOfCards[i] = (qrand()%32)+1;
        for(int j=0;j<i;j++){
            if(sortOfDeckOfCards[j] == sortOfDeckOfCards[i])
                i--;
        }
    }
    /*sortOfDeckOfCards[31] = 4;
    sortOfDeckOfCards[29] = 3;
    sortOfDeckOfCards[27] = 17;
    sortOfDeckOfCards[25] = 25;*/
}

bool CardUtil::isNotEnabledPlayerCards(int cards[4],bool enabledCards[4]){
    for(int i=0;i<4;i++){
        if(cards[i] >= 0 && !enabledCards[i]){
            return true;
        }
    }
    return false;
}

QSize CardUtil::getCardSize(){
    return QSize(76,119);
}

void CardUtil::deleteCardsInCentral(int *cardsInCentral){
    for(int i=0;i<8;i++)
        cardsInCentral[i] = -1;
}

/*void CardUtil::addCardsToEnemyEndPlayer(int *enemyCards,int *playerCards,int *cardSum,int *deckOfCards){

}*/
