#include "desktopview.h"

#include <QtCore/QPoint>
#include <QtCore/QSize>
#include <QtCore/QRect>
#include <QtGui/QImage>
#include <QtGui/QBrush>
#include <QtGui/QPainter>
//#include <QtGui/QFont>
#include <QtGui/QRgb>

DesktopView::DesktopView(){}

void DesktopView::setDesktopBackground(QSize size){
    size.setHeight(size.height()-menuBarSize);
    //delete desktopBmp;
    desktopBmp = new QImage(size, QImage::Format_ARGB32);
    size.setHeight(size.height()-statusBarHeight);
    clearBox(QRect(QPoint(0,0),size));
}

void DesktopView::clearBox(QRect rect){
    QPainter p(desktopBmp);
    QBrush brush(QImage(QString(":/pics/background.png")));
    p.fillRect(rect,brush);
    p.end();
}

void DesktopView::drawCard(QPoint point, int cardImageId, bool isSelected){
    QImage cardImage;
    if(cardImageId != 0)
        cardImage = QImage(QString(":/pics/cards/"+QString::number(cardImageId)+".png"));
    else
        cardImage = QImage(QString(":/pics/cards/back1.png"));

    QPainter p(desktopBmp);
    if(isSelected){
        changeToSelectedCard(&cardImage);
    }
    p.drawImage(point,cardImage);
    p.end();
}

void DesktopView::drawText(QPoint point, QString text){
    QPainter p(desktopBmp);
    //QFont *font = new QFont();
    //font->setWeight(30);
    //p.setFont(*font);
    p.drawText(point,text);
    p.end();
}

QImage* DesktopView::getDesktopBmp(){
    return desktopBmp;
}

void DesktopView::changeToSelectedCard(QImage *image){
    QRgb yellow = qRgb(255,255,0);
    for(int y=image->height()-1;y>=0;y--){
        for(int x =image->width()-1;x>=0;x--){
            QRgb pixel = image->pixel(x,y);
            if(qRed(pixel) == 255 && qGreen(pixel) == 255 && qBlue(pixel) == 255){
                image->setPixel(x,y,yellow);
            }
        }
    }
}

DesktopView::~DesktopView(){
    delete desktopBmp;
}
