#include <QtCore/QSize>
#include <QtCore/QPoint>
#include <iostream>

#include "humanplayer.h"

HumanPlayer::HumanPlayer(){
    selectedCardId = -1;
    setFalseToAllEnabledCards();
}

void HumanPlayer::setFalseToAllEnabledCards(){
    for(int i=0;i<4;i++)
        //if(enabledCards[i])
            enabledCards[i] = false;
}

void HumanPlayer::setTrueToAllEnabledCards(){
    for(int i=0;i<4;i++)
        if(cards[i] != -1)
            enabledCards[i] = true;
}

bool* HumanPlayer::getEnabledCards(){
    return enabledCards;
}

void HumanPlayer::setPlayerCardsRect(QSize cardSize,int menuBarHeight){
    QPoint tmpCardPosition;
    for(int i=0;i<4;i++){
        tmpCardPosition = cardsPosition[i];
        tmpCardPosition.setY(tmpCardPosition.y()+menuBarHeight);

        playerCardsRect[i].setTopLeft(tmpCardPosition);
        playerCardsRect[i].setSize(cardSize);
    }
}

int HumanPlayer::selectedCard(QPoint clickedPoint){
    int cardId = -1;

    for(int i=0;i<4;i++){
        if(enabledCards[i]){
            if(playerCardsRect[i].contains(clickedPoint)){
                cardId = i;
            }
        }
    }
    return cardId;
}

QRect HumanPlayer::getPlayerCardsRect(int id,int menuBarHeight){
    QPoint tmpPoint = playerCardsRect[id].topLeft();
    tmpPoint.setY(tmpPoint.y()-menuBarHeight);

    QRect tmpRect = QRect(tmpPoint,playerCardsRect[id].size());

    return tmpRect;
}

HumanPlayer::~HumanPlayer(){}
