#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QtGui/QMainWindow>
#include "desktopview.h"

class DesktopCore;
class QPushButton;
class QAction;

class MainWindow : public QMainWindow{
  Q_OBJECT
  public:
    MainWindow();
    ~MainWindow();
    DesktopView* desktopView;
    DesktopCore* desktopCore;

    void setAllowButton();
    void endOfGame(int,int,int,int);
    void setWhoStartTheLastRound(int);
    void setStatusBarMessage(int);

    //enum StatusBarMessage{Delete,EnemyStart,PlayerStart,EnemyInAction,PlayerInAction};
    //Q_DECLARE_FLAGS(StatusBarMessages, StatusBarMessage)

  private:
    int gameMode; //0=player start the round, 1=enemy, 2=random
    int whoStartTheLastRound; //0=player, 1=enemy
    QPushButton* allowButton;
    bool resizedWindow;

    QAction *msec500;
    QAction *msec1000;
    QAction *msec1500;

    void initMenuBar();
    void initStatusBar();
    void setAllowButtonPosition();

  protected:
    void paintEvent(QPaintEvent *);
    void mousePressEvent(QMouseEvent *);
    void resizeEvent(QResizeEvent *);
    void closeEvent(QCloseEvent *);
    void mouseMoveEvent(QMouseEvent *);

  private slots:
    void newGameAct();
    void allowAct();
    void aboutAct();
    void speedAct();
};

//Q_DECLARE_OPERATORS_FOR_FLAGS(MainWindow::StatusBarMessages)

#endif // MAINWINDOW_H
