#include <QtGui/QGroupBox>
#include <QtGui/QLayout>
#include <QtGui/QRadioButton>
#include <QtGui/QDialogButtonBox>

#include "newgamedialog.h"

NewGameDialog::NewGameDialog(int gameMode){
    //setWindowTitle(QString::fromUtf8("Új játék"));
    setWindowTitle(tr("New game"));
    resize(300,200);
    setModal(true);
    setResult(0);
    selectedRadioButtonId = gameMode;

    //radioPlayer = new QRadioButton(QString::fromUtf8("Játékos"));
    radioPlayer = new QRadioButton(tr("Player"));
    //radioBot = new QRadioButton(QString::fromUtf8("Gép"));
    radioBot = new QRadioButton(tr("Bot"));
    //radioRandom = new QRadioButton(QString::fromUtf8("Véletlenszerűen"));
    radioRandom = new QRadioButton(tr("Random"));

    if(gameMode == 0)
        radioPlayer->setChecked(true);
    if(gameMode == 1)
        radioBot->setChecked(true);
    if(gameMode == 2)
        radioRandom->setChecked(true);

    connect(radioPlayer,SIGNAL(clicked()),this,SLOT(radioButtonSlot()));
    connect(radioBot,SIGNAL(clicked()),this,SLOT(radioButtonSlot()));
    connect(radioRandom,SIGNAL(clicked()),this,SLOT(radioButtonSlot()));

    QVBoxLayout *boxLayout = new QVBoxLayout();
    boxLayout->addWidget(radioPlayer);
    boxLayout->addWidget(radioBot);
    boxLayout->addWidget(radioRandom);

    //QGroupBox *groupBox = new QGroupBox(QString::fromUtf8("Kezdje:"));
    QGroupBox *groupBox = new QGroupBox(tr("Who start the first round:"));
    groupBox->setLayout(boxLayout);

    QDialogButtonBox *buttonBox = new QDialogButtonBox(QDialogButtonBox::Ok | QDialogButtonBox::Cancel );
    connect(buttonBox,SIGNAL(accepted()),this,SLOT(startButtonSlot()));
    connect(buttonBox,SIGNAL(rejected()),this,SLOT(cancelSlot()));

    QVBoxLayout *mainLayout = new QVBoxLayout();
    mainLayout->addWidget(groupBox);
    mainLayout->addWidget(buttonBox);

    setLayout(mainLayout);
}

void NewGameDialog::radioButtonSlot(){
    if(radioPlayer->isChecked())
        selectedRadioButtonId = 0;
    if(radioBot->isChecked())
        selectedRadioButtonId = 1;
    if(radioRandom->isChecked())
        selectedRadioButtonId = 2;
}

void NewGameDialog::startButtonSlot(){
    setResult(1);
    setVisible(false);

}

void NewGameDialog::cancelSlot(){
    setVisible(false);
}

int NewGameDialog::getSelectedRadioButtonId(){
    return selectedRadioButtonId;
}

NewGameDialog::~NewGameDialog(){
    delete radioPlayer;
    delete radioBot;
    delete radioRandom;
}
