#include "resultdialog.h"

#include <QtGui/QDialog>
#include <QtGui/QGroupBox>
#include <QtGui/QLayout>
#include <QtGui/QPushButton>
#include <QtGui/QLCDNumber>
#include <QtGui/QDialogButtonBox>

//#include "qgauge.h"

resultDialog::resultDialog(int enemyPoints,int playerPoints,int enemyWinRounds,int playerWinRounds){
    setResult(0);

    //setWindowTitle(QString::fromUtf8("Eredmény"));
    setWindowTitle(tr("Results"));
    resize(400,400);
    setModal(true);

    /*QGauge *enemyGauge = new QGauge();
    enemyGauge->setMinValue(0);
    enemyGauge->setMaxValue(80);
    enemyGauge->setValue(enemyPoints);
    enemyGauge->enableAlarm(false);
    enemyGauge->setNumTicks(8);
    enemyGauge->setPrecision(0);
    enemyGauge->setOrientation(QGauge::Vertical);
    enemyGauge->setEnabled(false);

    QGauge *playerGauge = new QGauge();
    playerGauge->setMinValue(0);
    playerGauge->setMaxValue(80);
    playerGauge->setValue(playerPoints);
    playerGauge->enableAlarm(false);
    playerGauge->setNumTicks(8);
    playerGauge->setPrecision(0);
    playerGauge->setOrientation(QGauge::Vertical);
    playerGauge->setEnabled(false);*/

    // tmp
    QLCDNumber *enemyPointsLCDNumber = new QLCDNumber();
    enemyPointsLCDNumber->setSegmentStyle(QLCDNumber::Filled);
    enemyPointsLCDNumber->display(enemyPoints);
    // /tmp

    QVBoxLayout *enemyPointsLayout = new QVBoxLayout();
    //enemyPointsLayout->addWidget(enemyGauge);
    enemyPointsLayout->addWidget(enemyPointsLCDNumber);

    //QGroupBox *enemyPointsBox = new QGroupBox(QString::fromUtf8("Ellenfél:"));
    QGroupBox *enemyPointsBox = new QGroupBox(tr("Enemy:"));
    enemyPointsBox->setLayout(enemyPointsLayout);

    // tmp
    QLCDNumber *playerPointsLCDNumber = new QLCDNumber();
    playerPointsLCDNumber->setSegmentStyle(QLCDNumber::Filled);
    playerPointsLCDNumber->display(playerPoints);
    // /tmp

    QVBoxLayout *playerPointsLayout = new QVBoxLayout();
    //playerPointsLayout->addWidget(playerGauge);
    playerPointsLayout->addWidget(playerPointsLCDNumber);

    //QGroupBox *playerPointsBox = new QGroupBox(QString::fromUtf8("Játékos:"));
    QGroupBox *playerPointsBox = new QGroupBox(tr("Player:"));
    playerPointsBox->setLayout(playerPointsLayout);

    QHBoxLayout *allPointsLayout = new QHBoxLayout();
    allPointsLayout->addWidget(enemyPointsBox);
    allPointsLayout->addWidget(playerPointsBox);

    //QGroupBox *allPointsBox = new QGroupBox(QString::fromUtf8("Pontok:"));
    QGroupBox *allPointsBox = new QGroupBox(tr("Points:"));
    allPointsBox->setLayout(allPointsLayout);

    //
    QLCDNumber *enemyLCDNumber = new QLCDNumber();
    enemyLCDNumber->display(enemyWinRounds);

    QVBoxLayout *enemyWinRoundsLayout = new QVBoxLayout();
    enemyWinRoundsLayout->addWidget(enemyLCDNumber);

    //QGroupBox *enemyWinRoundsBox = new QGroupBox(QString::fromUtf8("Ellenfél:"));
    QGroupBox *enemyWinRoundsBox = new QGroupBox(tr("Enemy:"));
    enemyWinRoundsBox->setLayout(enemyWinRoundsLayout);

    QLCDNumber *playerLCDNumber = new QLCDNumber();
    playerLCDNumber->display(playerWinRounds);

    QVBoxLayout *playerWinRoundsLayout = new QVBoxLayout();
    playerWinRoundsLayout->addWidget(playerLCDNumber);

    //QGroupBox *playerWinRoundsBox = new QGroupBox(QString::fromUtf8("Játékos:"));
    QGroupBox *playerWinRoundsBox = new QGroupBox(tr("Player:"));
    playerWinRoundsBox->setLayout(playerWinRoundsLayout);

    QHBoxLayout *allWinRoundsLayout = new QHBoxLayout();
    allWinRoundsLayout->addWidget(enemyWinRoundsBox);
    allWinRoundsLayout->addWidget(playerWinRoundsBox);

    //QGroupBox *allWinRoundsBox = new QGroupBox(QString::fromUtf8("Megnyert körök:"));
    QGroupBox *allWinRoundsBox = new QGroupBox(tr("Won rounds:"));
    allWinRoundsBox->setLayout(allWinRoundsLayout);


    QVBoxLayout *resultsLayout = new QVBoxLayout();
    resultsLayout->addWidget(allPointsBox);
    resultsLayout->addWidget(allWinRoundsBox);

    //QPushButton *newGameButton = new QPushButton(QString::fromUtf8("Új játék"));
    QPushButton *newGameButton = new QPushButton(tr("New Game"));
    connect(newGameButton,SIGNAL(clicked()),this,SLOT(newGameAction()));

    //QPushButton *cancelButton = new QPushButton(QString::fromUtf8("Mégse"));
    QPushButton *cancelButton = new QPushButton(tr("Cancel"));
    connect(cancelButton,SIGNAL(clicked()),this,SLOT(cancelAction()));

    QDialogButtonBox *buttonBox = new QDialogButtonBox();
    buttonBox->addButton(newGameButton,QDialogButtonBox::ActionRole);
    buttonBox->addButton(cancelButton,QDialogButtonBox::ActionRole);

    QVBoxLayout *mainLayout = new QVBoxLayout();
    mainLayout->addLayout(resultsLayout);
    mainLayout->addWidget(buttonBox);

    setLayout(mainLayout);
}

void resultDialog::newGameAction(){
    setResult(1);
    setVisible(false);
}

void resultDialog::cancelAction(){
    setVisible(false);
}

resultDialog::~resultDialog(){}
